#include <sourcemod>
#include <sdktools>

#define BOMB_MODEL	"models/props/cs_militia/bottle03.mdl"
#define SMOKE_MODEL	"particle/smokestack.vmt"

public Plugin:myinfo = 
{
    name = "C4 Effects",
    author = "The End Is Near..., orig: NoTiCE",
	version     = "1.0",
    url = "http://world-source.ru/"
}

new g_iSmokeEntity = -1;

public OnPluginStart()
{
	HookEvent("bomb_planted",		Event_OnBombPlanted);
	HookEvent("bomb_begindefuse",	Event_OnBombBeginDefuse);
	HookEvent("bomb_abortdefuse",	Event_OnBombAbortDefuse);
	HookEvent("bomb_defused",		Event_OnBombDefused);
	HookEvent("bomb_exploded",		Event_OnBombExploded);
}

public OnMapStart()
{
	if (IsModelPrecached(BOMB_MODEL) == false)
	{
		PrecacheModel(BOMB_MODEL);
	}

	if (IsModelPrecached(SMOKE_MODEL) == false)
	{
		PrecacheModel(SMOKE_MODEL);
	}
}

public Event_OnBombPlanted(Handle:hEvent, const String:szEventName[], bool:bSilent)
{
	decl iBombEntity;
	if ((iBombEntity = FindEntityByClassname(-1, "planted_c4")) != -1)
	{
		g_iSmokeEntity = CreateEntityByName("env_smokestack");
		if (g_iSmokeEntity != -1)
		{
			decl Float:fEntityOrigin[3];
			GetEntPropVector(iBombEntity, Prop_Send, "m_vecOrigin", fEntityOrigin);
			DispatchKeyValueVector(g_iSmokeEntity, "Origin", fEntityOrigin);

			SetEntityModel(iBombEntity, BOMB_MODEL);

			DispatchKeyValue(g_iSmokeEntity, "SmokeMaterial", SMOKE_MODEL);
			DispatchKeyValue(g_iSmokeEntity, "StartSize", "5");
			DispatchKeyValue(g_iSmokeEntity, "EndSize", "50");
			DispatchKeyValue(g_iSmokeEntity, "InitialState", "1");
			DispatchKeyValue(g_iSmokeEntity, "BaseSpread", "20");
			DispatchKeyValue(g_iSmokeEntity, "JetLength", "180");
			DispatchKeyValue(g_iSmokeEntity, "SpreadSpeed", "10");
			DispatchKeyValue(g_iSmokeEntity, "Speed", "30");
			DispatchKeyValue(g_iSmokeEntity, "Rate", "40");
			DispatchKeyValue(g_iSmokeEntity, "RenderAmt", "75");
			DispatchKeyValue(g_iSmokeEntity, "RenderColor", "255 0 0");

			if (DispatchSpawn(g_iSmokeEntity) == true)
			{
				AcceptEntityInput(g_iSmokeEntity, "TurnOn");
			}
			else
			{
				g_iSmokeEntity = -1;
			}
		}
	}
}

public Event_OnBombBeginDefuse(Handle:hEvent, const String:szEventName[], bool:bSilent)
{
	ChangeColorEffect("0 0 255");
}

public Event_OnBombAbortDefuse(Handle:hEvent, const String:szEventName[], bool:bSilent)
{
	ChangeColorEffect("255 0 0");
}

public Event_OnBombDefused(Handle:hEvent, const String:szEventName[], bool:bSilent)
{
	ChangeColorEffect("0 255 0");
}

public Event_OnBombExploded(Handle:hEvent, const String:szEventName[], bool:bSilent)
{
	if (g_iSmokeEntity != -1)
	{
		AcceptEntityInput(g_iSmokeEntity, "TurnOff");
	}
}

ChangeColorEffect(const String:szRenderColor[])
{
	if (g_iSmokeEntity != -1)
	{
		AcceptEntityInput(g_iSmokeEntity, "TurnOff");
		DispatchKeyValue(g_iSmokeEntity, "RenderColor", szRenderColor);
		AcceptEntityInput(g_iSmokeEntity, "TurnOn");
	}
}